Subject: Re: [PATCH net 0/7] virtio_net: Fix problems around XDP tx and napi_tx

From: "Michael S. Tsirkin" <[email-masked]>
Date: Thu, 17 Jan 2019 09:55:35 -0500

On Thu, Jan 17, 2019 at 08:20:38PM +0900, Toshiaki Makita wrote:
> While I'm looking into how to account standard tx counters on XDP tx
> processing, I found several bugs around XDP tx and napi_tx.
> 
> Patch1: Fix oops on error path. Patch2 depends on this.
> Patch2: Fix memory corruption on freeing xdp_frames with napi_tx enabled.
> Patch3: Minor fix patch5 depends on.
> Patch4: Fix memory corruption on processing xdp_frames when XDP is disabled.
>   Also patch5 depends on this.
> Patch5: Fix memory corruption on processing xdp_frames while XDP is being
>   disabled.
> Patch6: Minor fix patch7 depends on.
> Patch7: Fix memory corruption on freeing sk_buff or xdp_frames when a normal
>   queue is reused for XDP and vise versa.
> 
> Signed-off-by: Toshiaki Makita <[email-masked]>

Series:

Acked-by: Michael S. Tsirkin <[email-masked]>

I guess we need this stuff on stable?
I'm especially happy with Patch7 as it makes my BQL
work a bit easier.

> Toshiaki Makita (7):
>   virtio_net: Don't enable NAPI when interface is down
>   virtio_net: Don't call free_old_xmit_skbs for xdp_frames
>   virtio_net: Fix not restoring real_num_rx_queues
>   virtio_net: Fix out of bounds access of sq
>   virtio_net: Don't process redirected XDP frames when XDP is disabled
>   virtio_net: Use xdp_return_frame to free xdp_frames on destroying vqs
>   virtio_net: Differentiate sk_buff and xdp_frame on freeing
> 
>  drivers/net/virtio_net.c | 154 +++++++++++++++++++++++++++++++++--------------
>  1 file changed, 109 insertions(+), 45 deletions(-)
> 
> -- 
> 1.8.3.1
>